;
;	Vltozk cmkiosztsa az SDC-hez
;

;
; Konstansok
;

; 0. vide md
grmode0		.equ	0		; grafikus md: 0-> 2-szn  1-> 4-szn
pal0_0		.equ	000h		; paletta kdok: fekete
pal1_0		.equ	050h		; zld (fehr: 55h)
pal2_0		.equ	000h		; -
pal3_0		.equ	000h		; -
head_ln2	.equ	2		; az oszlopfejlcek sora
fst_ln2		.equ	3		; az els bejegyzst tartalmaz sor a kpernyn
lst_ln2		.equ	22		; az utols bejegyzs sora
sum_ln2		.equ	24		; a legals sszegz sor
name_cl2	.equ	4		; a nv oszlop X pozcija
pnmu_cl2	.equ	60		; panelsorszm X pozcija
nclms2		.equ	5		; kirand oszlopok szma (nv, kit, mret, dtum, attr.)
sel_start2	.equ	2		; kivlasztott sor invertlsnak kezdete
selch2		.equ	48		; kivlasztott sor invertlt bjtjainak szma
inv_start2	.equ	1		; teljes sor invertlsnak kezdete bjtban
inv_full2	.equ	62		; invertland teljes sor hossza bjtban
paper2		.equ	0		; httr szn az tvonal s zenet sorhoz
ink2		.equ	1		; bet szn az tvonal s zenet sorhoz
fill2		.equ	000h		; kitlt bjt az tvonal s zenet sor trlshez

; 1. vide md
grmode		.equ	1		; grafikus md: 0-> 2-szn  1-> 4-szn
pal0		.equ	011h		; paletta kdok: sttkkeszld ( v. szrke 015h)
pal1		.equ	000h		; fekete
pal2		.equ	055h		; fehr
pal3		.equ	004h		; sttvrs
head_ln		.equ	3		; az oszlopfejlcek sora
fst_ln		.equ	4		; az els bejegyzst tartalmaz sor a kpernyn
lst_ln		.equ	21		; az utols bejegyzs sora
sum_ln		.equ	24		; a legals sszegz sor
name_cl		.equ	3		; a nv oszlop X pozcija
pnmu_cl		.equ	28		; panelsorszm X pozcija
nclms		.equ	3		; kirand oszlopok szma (nv, kit, mret)
sel_start	.equ	4		; kivlasztott sor invertlsnak kezdete
selch		.equ	50		; kivlasztott sor invertlt bjtjainak szma
inv_start	.equ	2		; teljes sor invertlsnak kezdete bjtban
inv_full	.equ	60		; invertland teljes sor hossza bjtban
paper		.equ	1		; httr szn az tvonal s zenet sorhoz
ink		.equ	2		; bet szn az tvonal s zenet sorhoz
fill		.equ	0F0h		; kitlt bjt az tvonal s zenet sor trlshez

;
; Grafikus tblzatok cmzse
;
#define	IY_GRMODE	(IY+0)
#define IY_PAL0		(IY+1)
#define IY_PAL1		(IY+2)
#define IY_PAL2		(IY+3)
#define IY_PAL3		(IY+4)
#define	IY_HEADLN	(IY+5)
#define	IY_FSTLN	(IY+6)
#define	IY_LSTLN	(IY+7)
#define	IY_SUMLN	(IY+8)
#define	IY_NAMECL	(IY+9)
#define	IY_PNUMCL	(IY+10)
#define	IY_NCLMS	(IY+11)
#define	IY_MAXLN	(IY+12)
#define	IY_SCSUM_L	(IY+13)
#define	IY_SCSUM_H	(IY+14)
#define	IY_SCUP_L	(IY+15)
#define	IY_SCUP_H	(IY+16)
#define	IY_SCDW_L	(IY+17)
#define	IY_SCDW_H	(IY+18)
#define IY_FRMLNS	(IY+19)
#define IY_SELSTART	(IY+20)
#define IY_SELCH	(IY+21)
#define IY_INVSTART	(IY+22)
#define IY_INVFULL	(IY+23)
#define IY_PAPER	(IY+24)
#define IY_INK		(IY+25)
#define IY_CLRFILL	(IY+26)
#define IY_NEXT_L	(IY+27)
#define IY_NEXT_H	(IY+28)

#ifdef IFCARD
  #define VID_PAGE_CFG	0D0h		; vidememria belapozsi rtke (U0, U1, VID, IOMEM/EXT)
  #define SYS_PAGE_CFG	0E0h		; SYS ROM      belapozsi rtke (SYS, U1, U2, IOMEM/EXT)
#endif

#ifdef CARTRIDGE
  #define VID_PAGE_CFG	010h		; vidememria belapozsi rtke (U0, U1, VID, CART)
  #define SYS_PAGE_CFG	020h		; SYS ROM      belapozsi rtke (SYS, U1, U2, CART)
#endif


  #define VID_PAGE_CFG	090h		; vidememria belapozsi rtke (U0, U1, VID, U3)


COL_NEV		.equ	1		; nv oszlop relatv X koordintja
COL_KIT		.equ	9		; kiterjeszts
COL_MERET	.equ	16		; fjlmret
COL_DATUM	.equ	29		; dtum
COL_ATTR	.equ	42		; attribtum

SORT_NEV	.equ	1		; rendezs nv szerint
SORT_KIT	.equ	2		; rendezs kiterjeszts szerint
SORT_MERET	.equ	3		; rendezs fjlmret szerint
SORT_DATUM	.equ	4		; rendezs dtum szerint
SORT_ATTR	.equ	5		; rendezs attribtum szerint

tvfst_ln	.equ	2		; szvegnz els megjelentsre hasznlt sora
tvlst_ln	.equ	24		; szvegnz utols megjelentsre hasznlt sora
tv_nlines	.equ	tvlst_ln -tvfst_ln +1	; a kpernyn megjelenthet sorok szma
tvfullscr	.equ	(tv_nlines) * 8		; egy kpernyn megjelenthet adatbjtok szma
tv_linlen	.equ	9+(4*8)+2	; HEXA mdban az egy sorba kirt karakterek szma
tv_tmaxlen	.equ	252		; TEXT mdban a maximlis kezelhet sorhossz (4 * 63 karakter)


;
; Vltozk a platformfgg memriaterleten
;

#ifdef IFCARD
  #define  fk_RAMstart	0D000h		; segdprogramok RAM memrijnak kezdete interface krtyn
  #define  fk_RAMend	0D800h		; RAM memria vge
#endif

#ifdef CARTRIDGE
  #define  fk_RAMstart	0F000h		; segdprogramok RAM memrijnak kezdete cartridge-nl
  #define  fk_RAMend	0FC00h		; RAM memria vge
#endif


  #define  fk_RAMstart	SDC_DATAMEM	; segdprogramok RAM memrijnak kezdete felhasznli programban
  #define  fk_RAMend	SDC_DATAEND	; RAM memria vge (gy, hogy "nbj_max" ne legyen nagyobb 255-nl)


;
; Kzsen hasznlhat vltozk a partci-kezelvel (IFCARD vagy CARTRIDGE md)
;
bcdMSB		.equ	fk_RAMstart	; BCD alak szm trolshoz a BIN->ASCII konverzinl (5 bjt)
bcdLSB		.equ	fk_RAMstart+4
numbuff_L	.equ	fk_RAMstart+5	; szmbuffer BIN->BCD konverzhoz, als sz (2 bjt)
numbuff_H	.equ	fk_RAMstart+7	; szmbuffer BIN->BCD konverzhoz, fels sz (2 bjt)
origvmode	.equ	fk_RAMstart+9	; a programba val belpskori videmd (1 bjt)
;
common_end	.equ	fk_RAMstart+10

;
; SDC vltozi
;
SDCstart	.equ	common_end
;
akt_ln		.equ	SDCstart	; az aktulisan kijellt sor szma (1 bjt)
akt_bj		.equ	SDCstart+1	; a tallt fjlnevek aktulis pointere (2 bjt)
xaktbj		.equ	SDCstart+3	; az aktulis fjlnv indexe (max. 255!) (1 bjt)
nbj		.equ	SDCstart+4	; a tallt bejegyzsek szma (1 bjt)
nfiles		.equ	SDCstart+5	; a tallt fjlnevek szma (1 bjt)
dircap		.equ	SDCstart+6	; az aktulis knyvtrban lv fjlok sszmrete (4 bjt)
retry_cnt	.equ	SDCstart+10	; jraprblkozsok szma (1 bjt)
sorttype	.equ	SDCstart+11	; rendezs szempontja (nv, kit. stb.) (1 bjt)
path_ptr	.equ	SDCstart+12	; az aktulis tvonalnv mutatja (2 bjt)
dest_ptr	.equ	SDCstart+14	; a cl tvonalnv mutatja (2 bjt)
nselect		.equ	SDCstart+16	; kivlasztott fjlnevek szma (1 bjt)
selcap		.equ	SDCstart+17	; a kivlasztott fjlok sszmrete (4 bjt)
fmanid		.equ	SDCstart+21	; az aktulis fjlmanipulcis funkci kdja (0..4) (1 bjt)
rec_level	.equ	SDCstart+22	; az aktulis rekurzis mlysg (a fjlnv kijelzshez) (1 bjt)

;
; Platform fggen elhelyezked vltozk
; (IFCARD vagy CARTRIDGE md esetn az U0 RAM-ban, a CLI adatterletn)
;

  #define	strbuff	SDCstart+23	; kirsi string buffer (max. 127 karakter)


dptrbuff	.equ	strbuff  + 127	; adatmutat szvegmegjelentskor (4 bjt)
FCB_0		.equ	dptrbuff + 4	; az FCB-k azonosak a CLI ltal hasznltakkal
FCB_1		.equ	FCB_0 + 030h
FCB_2		.equ	FCB_1 + 030h
FCB_3		.equ	FCB_2 + 030h
FCB_4		.equ	FCB_3 + 030h

FPB		.equ	FCB_4 + 030h	; SDC_LIBRARY mdban FPB IX,HL,DE,BC rtknek trolshoz (8 bjt)

;
; A fjlnz vltozi (tfedsben FCB4-el)
;
scrptr		.equ	FCB_4		; kperny tetejn kijelzett adat kezdcme a fjlban (4 bjt)
ln_dsply	.equ	scrptr + 4	; megjelenthet sorhossz 62-> nincs sortrs 255-> sortrs (1 bjt)
linlenbuff	.equ	scrptr + 5	; kpernysorokban lv karakterek szmt tartalmaz tmb (23 bjt)
dbufflen	.equ	scrptr + 28	; a CLI pufferbe olvasott bjtok szma (2 bjt)

;
; Tmbvltozk
;

  #define	buffstart	FPB + 008h

;
fnamepre	.equ	buffstart	; fjlnv eltti karakter (pl. alknyvtrat jelz '\') (1 bjt)
fnamebuff	.equ	buffstart+1	; 8.3-as fjlnv + lezr nulla (14 bjt)
;
pathbuff1	.equ	buffstart+15	; knyvtrtvonal #1 (fjlnv nlkl) (67 bjt)
pathbuff2	.equ	buffstart+82	; knyvtrtvonal #2 (fjlnv nlkl) (68 bjt)
;
sortbuff	.equ	buffstart+150	; rendezett knyvtrbejegyzs-cmeket tartalmaz buffer (nbj_max  * 2 bjt)
;
; fjlnevek maximlis szma a teljes htralv RAM terletbl szmolva
;
nbj_max		.equ	(fk_RAMend - sortbuff) / 22	; 20 + 2 bjt / bejegyzs
;
nevtbl		.equ	sortbuff + (2 * nbj_max)	; az aktulis knyvtr bejegyzsei 20 bjtos struktrkban (nbj_max * 20 bjt)

;
#if (nbj_max > 255)
	.echo "\r\n*** Hiba: nbj_max nagyobb 255-nel!!! ***\r\n"
	.echo "SDC_DATAEND-et csokkenteni kell!\r\n\r\n"
#else
	.echo "\r\nAz SDC altal egy konyvtarban kezelheto fajlok maximalis szama: "
	.echo nbj_max
	.echo "\r\n\r\n"
#endif

.end
